Subject: RE: bug#48134: [External] : bug#48134: When sitting on top of a M-x item in the manual

From: Drew Adams <[email-masked]>
Date: Sat, 1 May 2021 16:28:38 +0000

Here we go again...

> If you want to suggest that a similar implementation be
> included in Emacs, it is enough to mention the existence
> of the solution.

I did that.  I did better than that.  I suggested
adding a similar, _general_ feature, instead of
arguing for this or that particular way to provide
such a feature.

> You could also describe your proposed implementation,
> while you are at that, as that gives ideas for our
> internal implementation.

... and I described the "solution" whose "existence"
I mentioned (and pointed to its code).

What's missing in Emacs is a simple way to pull text
at point into the minibuffer at point - into ANY
minibuffer (not just for `M-x' or completion).

Just what text gets pulled in, and how, is worth
discussing in the bug thread perhaps.  What I
offered was a suggestion to do so in a general way,
by e.g. binding a key in the most general minibuffer
keymap (not in a completion keymap).

I provided info about one particular example of such
a feature, describing possible behaviors wrt pulling
in text at point.  Maybe worth considering in the
context of the feature request, as food for thought.

But feel free to ignore those food-for-thought
details.  (The general suggestion has been made
before - and ignored.)

How is your rant against my contributed suggestion
helpful?

> looks like a shameless plug to me

I'm not plugging anything.  I made a point of
saying that this feature really has nothing to do
with the rest of Icicles, and that it's simple for
Emacs to implement it or something similar.

It's in Icicles only because it wasn't in Emacs and
because it's useful for interacting with the
minibuffer (which is important for using Icicles).

It would be good for Emacs itself to have such a
feature.  That's the point.  It's not about Icicles
having such a feature.

The doc I pointed to describes what the feature
does.  That info could be helpful in deciding what
to do for Emacs.  That's the point of describing
it for you.  If you don't find it helpful, ignore
it.

> Please don't clutter the bug tracker with such
> useless information.

Please consider implementing the enhancement
requested by Jidanni.  Just how that's done is less
important than doing it.  It could have been done
decades ago, when first suggested.

Do you really want a description of the Icicles
_implementation_ of this, as you say?  Describing
the behavior for users isn't enough?

Here's a high-level implementation description that
should be appropriate for this thread:

 1. Define a user option that provides functions
    that return a string of text at point or else
    nil.

 2. Call one of those functions when a user invokes
    the command for inserting text at point using
    some key (such as `M-.').

The option could be like what Icicles uses
(`icicle-thing-at-point-functions').  But it need
not be - it could be much simpler.

The way one of those functions is chosen could be
similar to what Icicles does.  But it need not be
- it could be much simpler.

I won't bore you more with the particular behavior
Icicles provides, or how.  That's not the point.

If you want more, just ask.  But again, I'm not
proposing that Emacs adopt the same behavior or
implementation.  I offered a description only as
food for thought.

To be extra clear: I _don't want_ more people to
use Icicles.  Really.  I don't have the time or
will to keep up with changes to vanilla Emacs
that make changes to my code necessary.  That's
life.

Icicles can, I think, offer food for thought, in
various ways.  It has already done so, resulting
in several other completion "frameworks" now.
That's all.  Food for thought.